#define BIT_SET(Value, Num)          (Value = Value | Num)
#define BIT_CLEAR(Value, Num)        (Value = (Value & (~Num)))
#define BIT_REVERSE(Value, Num)      (Value = Value ^ Num)

#define Sbi(Value, Num)          (Value = Value | Num)
#define Cbi(Value, Num)        (Value = (Value & (~Num)))
#define Tbi(Value, Num)      (Value = Value ^ Num)


typedef unsigned int DATA_LCD;

//-----------------------------------------------------------------------------
//shift resister
#define SHIFT_DATA_PORT			P2OUT
#define SHIFT_DATA_DDR			P2DIR
#define SHIFT_DATA_BIT			BIT3

#define SHIFT_CLK_PORT			P2OUT
#define SHIFT_CLK_DDR			P2DIR
#define SHIFT_CLK_BIT			BIT4

#define SHIFT_LATCH_PORT		P2OUT
#define SHIFT_LATCH_DDR			P2DIR
#define SHIFT_LATCH_BIT			BIT5

#define ShiftDataSet()			Sbi(SHIFT_DATA_PORT, SHIFT_DATA_BIT)
#define ShiftDataClear()		Cbi(SHIFT_DATA_PORT, SHIFT_DATA_BIT)
#define ShiftClkSet()			Sbi(SHIFT_CLK_PORT, SHIFT_CLK_BIT)
#define ShiftClkClear()			Cbi(SHIFT_CLK_PORT, SHIFT_CLK_BIT)
#define ShiftLatchSet()			Sbi(SHIFT_LATCH_PORT, SHIFT_LATCH_BIT)
#define ShiftLatchClear()		Cbi(SHIFT_LATCH_PORT, SHIFT_LATCH_BIT)

#define CbiShiftData(Data)		ShiftOut(BIT_CLEAR((m_ShiftData), (Data)))
#define	SbiShiftData(Data)		ShiftOut(BIT_SET((m_ShiftData), (Data)))
#define TbiShiftData(Data)		ShiftOut(BIT_REVERSE((m_ShiftData), (Data)))

#define MAX_SHIFT_NUM			16
#define _FIRST_595DATA			0x8000//(0x01<<MAX_SHIFT_NUM)
//-----------------------------------------------------------------------------
